Index: other-projects/maori-lang-detection/mongodb-data/counts_tentativeNonProductSites.json
===================================================================
--- other-projects/maori-lang-detection/mongodb-data/counts_tentativeNonProductSites.json	(revision 33806)
+++ other-projects/maori-lang-detection/mongodb-data/counts_tentativeNonProductSites.json	(revision 33806)
@@ -0,0 +1,191 @@
+/* 1 */
+{
+    "_id" : "us",
+    "count" : 475.0
+}
+
+/* 2 */
+{
+    "_id" : "cn",
+    "count" : 114.0
+}
+
+/* 3 */
+{
+    "_id" : "nz",
+    "count" : 98.0
+}
+
+/* 4 */
+{
+    "_id" : "fr",
+    "count" : 36.0
+}
+
+/* 5 */
+{
+    "_id" : "de",
+    "count" : 26.0
+}
+
+/* 6 */
+{
+    "_id" : "nl",
+    "count" : 22.0
+}
+
+/* 7 */
+{
+    "_id" : "au",
+    "count" : 17.0
+}
+
+/* 8 */
+{
+    "_id" : "ca",
+    "count" : 13.0
+}
+
+/* 9 */
+{
+    "_id" : "dk",
+    "count" : 8.0
+}
+
+/* 10 */
+{
+    "_id" : "es",
+    "count" : 7.0
+}
+
+/* 11 */
+{
+    "_id" : "gb",
+    "count" : 7.0
+}
+
+/* 12 */
+{
+    "_id" : "cz",
+    "count" : 4.0
+}
+
+/* 13 */
+{
+    "_id" : "it",
+    "count" : 3.0
+}
+
+/* 14 */
+{
+    "_id" : "at",
+    "count" : 3.0
+}
+
+/* 15 */
+{
+    "_id" : "ch",
+    "count" : 2.0
+}
+
+/* 16 */
+{
+    "_id" : "ro",
+    "count" : 2.0
+}
+
+/* 17 */
+{
+    "_id" : "il",
+    "count" : 2.0
+}
+
+/* 18 */
+{
+    "_id" : "unknown",
+    "count" : 2.0
+}
+
+/* 19 */
+{
+    "_id" : "hk",
+    "count" : 2.0
+}
+
+/* 20 */
+{
+    "_id" : "jp",
+    "count" : 2.0
+}
+
+/* 21 */
+{
+    "_id" : "ie",
+    "count" : 2.0
+}
+
+/* 22 */
+{
+    "_id" : "ua",
+    "count" : 2.0
+}
+
+/* 23 */
+{
+    "_id" : "se",
+    "count" : 1.0
+}
+
+/* 24 */
+{
+    "_id" : "gr",
+    "count" : 1.0
+}
+
+/* 25 */
+{
+    "_id" : "ru",
+    "count" : 1.0
+}
+
+/* 26 */
+{
+    "_id" : "eu",
+    "count" : 1.0
+}
+
+/* 27 */
+{
+    "_id" : "bg",
+    "count" : 1.0
+}
+
+/* 28 */
+{
+    "_id" : "fi",
+    "count" : 1.0
+}
+
+/* 29 */
+{
+    "_id" : "sg",
+    "count" : 1.0
+}
+
+/* 30 */
+{
+    "_id" : "tr",
+    "count" : 1.0
+}
+
+/* 31 */
+{
+    "_id" : "mx",
+    "count" : 1.0
+}
+
+/* 32 */
+{
+    "_id" : "ir",
+    "count" : 1.0
+}
Index: other-projects/maori-lang-detection/mongodb-data/geojson-features_tentativeNonProductSites.json
===================================================================
--- other-projects/maori-lang-detection/mongodb-data/geojson-features_tentativeNonProductSites.json	(revision 33806)
+++ other-projects/maori-lang-detection/mongodb-data/geojson-features_tentativeNonProductSites.json	(revision 33806)
@@ -0,0 +1,1 @@
+{"type":"FeatureCollection","features":[{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-127.712891,37.09024],[-127.712891,66.77774],[-63.712891,66.77774],[-63.712891,37.09024],[-127.712891,37.09024]]]},"properties":{"code":"US","count":475,"region":"United States"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[96.195397,35.86166],[96.195397,64.36166],[112.195397,64.36166],[112.195397,35.86166],[96.195397,35.86166]]]},"properties":{"code":"CN","count":114,"region":"China"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[172.885971,-40.900557],[172.885971,57.099443],[176.885971,57.099443],[176.885971,-40.900557],[172.885971,-40.900557]]]},"properties":{"code":"NZ","count":98,"region":"New Zealand"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[0.21374899999999997,46.227638],[0.21374899999999997,82.227638],[4.213749,82.227638],[4.213749,46.227638],[0.21374899999999997,46.227638]]]},"properties":{"code":"FR","count":36,"region":"France"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[8.451526,51.165691],[8.451526,77.16569100000001],[12.451526,77.16569100000001],[12.451526,51.165691],[8.451526,51.165691]]]},"properties":{"code":"DE","count":26,"region":"Germany"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[3.2912660000000002,52.132633],[3.2912660000000002,74.132633],[7.291266,74.132633],[7.291266,52.132633],[3.2912660000000002,52.132633]]]},"properties":{"code":"NL","count":22,"region":"Netherlands"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[131.775136,-25.274398],[131.775136,-8.274398000000001],[135.775136,-8.274398000000001],[135.775136,-25.274398],[131.775136,-25.274398]]]},"properties":{"code":"AU","count":17,"region":"Australia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-108.346771,56.130366],[-108.346771,69.13036600000001],[-104.346771,69.13036600000001],[-104.346771,56.130366],[-108.346771,56.130366]]]},"properties":{"code":"CA","count":13,"region":"Canada"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[7.501785,56.26392],[7.501785,64.26392],[11.501785,64.26392],[11.501785,56.26392],[7.501785,56.26392]]]},"properties":{"code":"DK","count":8,"region":"Denmark"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.74922,40.463667],[-5.74922,47.463667],[-1.7492200000000002,47.463667],[-1.7492200000000002,40.463667],[-5.74922,40.463667]]]},"properties":{"code":"ES","count":7,"region":"Spain"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.435973000000001,55.378051],[-5.435973000000001,62.378051],[-1.4359730000000002,62.378051],[-1.4359730000000002,55.378051],[-5.435973000000001,55.378051]]]},"properties":{"code":"GB","count":7,"region":"United Kingdom"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[13.472962,49.817492],[13.472962,53.817492],[17.472962000000003,53.817492],[17.472962000000003,49.817492],[13.472962,49.817492]]]},"properties":{"code":"CZ","count":4,"region":"Czech Republic"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[10.56738,41.87194],[10.56738,44.87194],[14.56738,44.87194],[14.56738,41.87194],[10.56738,41.87194]]]},"properties":{"code":"IT","count":3,"region":"Italy"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[12.550072,47.516231],[12.550072,50.516231],[16.550072,50.516231],[16.550072,47.516231],[12.550072,47.516231]]]},"properties":{"code":"AT","count":3,"region":"Austria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[6.227512000000001,46.818188],[6.227512000000001,48.818188],[10.227512,48.818188],[10.227512,46.818188],[6.227512000000001,46.818188]]]},"properties":{"code":"CH","count":2,"region":"Switzerland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[22.96676,45.943161],[22.96676,47.943161],[26.96676,47.943161],[26.96676,45.943161],[22.96676,45.943161]]]},"properties":{"code":"RO","count":2,"region":"Romania"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[32.851612,31.046051],[32.851612,33.046051],[36.851612,33.046051],[36.851612,31.046051],[32.851612,31.046051]]]},"properties":{"code":"IL","count":2,"region":"Israel"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[55.0,-70.0],[55.0,-68.0],[59.0,-68.0],[59.0,-70.0],[55.0,-70.0]]]},"properties":{"code":"UNKNOWN","count":2,"region":"UNKNOWN"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[112.109497,22.396428],[112.109497,24.396428],[116.109497,24.396428],[116.109497,22.396428],[112.109497,22.396428]]]},"properties":{"code":"HK","count":2,"region":"Hong Kong"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[136.252924,36.204824],[136.252924,38.204824],[140.252924,38.204824],[140.252924,36.204824],[136.252924,36.204824]]]},"properties":{"code":"JP","count":2,"region":"Japan"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-10.24389,53.41291],[-10.24389,55.41291],[-6.24389,55.41291],[-6.24389,53.41291],[-10.24389,53.41291]]]},"properties":{"code":"IE","count":2,"region":"Ireland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[29.16558,48.379433],[29.16558,50.379433],[33.16558,50.379433],[33.16558,48.379433],[29.16558,48.379433]]]},"properties":{"code":"UA","count":2,"region":"Ukraine"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[16.643501,60.128161],[16.643501,61.128161],[20.643501,61.128161],[20.643501,60.128161],[16.643501,60.128161]]]},"properties":{"code":"SE","count":1,"region":"Sweden"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[19.824312,39.074208],[19.824312,40.074208],[23.824312,40.074208],[23.824312,39.074208],[19.824312,39.074208]]]},"properties":{"code":"GR","count":1,"region":"Greece"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[103.318756,61.52401],[103.318756,62.52401],[107.318756,62.52401],[107.318756,61.52401],[103.318756,61.52401]]]},"properties":{"code":"RU","count":1,"region":"Russia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-22.0,50.0],[-22.0,51.0],[-18.0,51.0],[-18.0,50.0],[-22.0,50.0]]]},"properties":{"code":"EU","count":1,"region":"Europe"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.48583,42.733883],[23.48583,43.733883],[27.48583,43.733883],[27.48583,42.733883],[23.48583,42.733883]]]},"properties":{"code":"BG","count":1,"region":"Bulgaria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.748151,61.92411],[23.748151,62.92411],[27.748151,62.92411],[27.748151,61.92411],[23.748151,61.92411]]]},"properties":{"code":"FI","count":1,"region":"Finland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[101.819836,1.352083],[101.819836,2.352083],[105.819836,2.352083],[105.819836,1.352083],[101.819836,1.352083]]]},"properties":{"code":"SG","count":1,"region":"Singapore"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[33.243322,38.963745],[33.243322,39.963745],[37.243322,39.963745],[37.243322,38.963745],[33.243322,38.963745]]]},"properties":{"code":"TR","count":1,"region":"Turkey"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-104.552784,23.634501],[-104.552784,24.634501],[-100.552784,24.634501],[-100.552784,23.634501],[-104.552784,23.634501]]]},"properties":{"code":"MX","count":1,"region":"Mexico"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[51.688046,32.427908],[51.688046,33.427908],[55.688046,33.427908],[55.688046,32.427908],[51.688046,32.427908]]]},"properties":{"code":"IR","count":1,"region":"Iran"}}]}
Index: other-projects/maori-lang-detection/mongodb-data/multipoint_tentativeNonProductSites.json
===================================================================
--- other-projects/maori-lang-detection/mongodb-data/multipoint_tentativeNonProductSites.json	(revision 33806)
+++ other-projects/maori-lang-detection/mongodb-data/multipoint_tentativeNonProductSites.json	(revision 33806)
@@ -0,0 +1,35 @@
+{"type":"MultiPoint","coordinates":
+[
+	[-95.712891,37.09024],
+	[104.195397,35.86166],
+	[174.885971,-40.900557],
+	[2.213749,46.227638],
+	[10.451526,51.165691],
+	[5.291266,52.132633],
+	[133.775136,-25.274398],
+	[-106.346771,56.130366],
+	[9.501785,56.26392],
+	[-3.74922,40.463667],
+	[-3.435973,55.378051],
+	[15.472962,49.817492],
+	[12.56738,41.87194],
+	[14.550072,47.516231],
+	[8.227512,46.818188],
+	[24.96676,45.943161],
+	[34.851612,31.046051],
+	[57.0,-70.0],
+	[114.109497,22.396428],
+	[138.252924,36.204824],
+	[-8.24389,53.41291],
+	[31.16558,48.379433],
+	[18.643501,60.128161],
+	[21.824312,39.074208],
+	[105.318756,61.52401],
+	[-20.0,50.0],
+	[25.48583,42.733883],
+	[25.748151,61.92411],
+	[103.819836,1.352083],
+	[35.243322,38.963745],
+	[-102.552784,23.634501],
+	[53.688046,32.427908]
+]}