Index: /other-projects/maori-lang-detection/mongodb-data/counts_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/counts_nonProductSites1_manualShortlist.json	(revision 33821)
+++ /other-projects/maori-lang-detection/mongodb-data/counts_nonProductSites1_manualShortlist.json	(revision 33821)
@@ -0,0 +1,45 @@
+/*
+Manually inspected non-NZ websites in tentativeNonProductSites1.json
+and made a list of sites with genuine Maori language content for each country.
+*/
+{
+    "_id" : "nz",
+    "count" : 176.0
+}
+{
+    "_id" : "us",
+    "count" : 25.0
+}
+{
+    "_id" : "au",
+    "count" : 3.0
+}
+{
+    "_id" : "de",
+    "count" : 2.0
+}
+{
+    "_id" : "dk",
+    "count" : 2.0
+}
+{
+    "_id" : "bg",
+    "count" : 1.0
+}
+{
+    "_id" : "cz",
+    "count" : 1.0
+}
+{
+    "_id" : "es",
+    "count" : 1.0
+}
+{
+    "_id" : "fr",
+    "count" : 1.0
+}
+{
+    "_id" : "ie",
+    "count" : 1.0
+}
+
Index: /other-projects/maori-lang-detection/mongodb-data/geojson-features_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/geojson-features_nonProductSites1_manualShortlist.json	(revision 33821)
+++ /other-projects/maori-lang-detection/mongodb-data/geojson-features_nonProductSites1_manualShortlist.json	(revision 33821)
@@ -0,0 +1,1 @@
+{"type":"FeatureCollection","features":[{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[170.885971,-40.900557],[170.885971,47.099443],[178.885971,47.099443],[178.885971,-40.900557],[170.885971,-40.900557]]]},"properties":{"code":"NZ","count":176,"region":"New Zealand"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-97.712891,37.09024],[-97.712891,62.09024],[-93.712891,62.09024],[-93.712891,37.09024],[-97.712891,37.09024]]]},"properties":{"code":"US","count":25,"region":"United States"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[131.775136,-25.274398],[131.775136,-22.274398],[135.775136,-22.274398],[135.775136,-25.274398],[131.775136,-25.274398]]]},"properties":{"code":"AU","count":3,"region":"Australia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[8.451526,51.165691],[8.451526,53.165691],[12.451526,53.165691],[12.451526,51.165691],[8.451526,51.165691]]]},"properties":{"code":"DE","count":2,"region":"Germany"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[7.501785,56.26392],[7.501785,58.26392],[11.501785,58.26392],[11.501785,56.26392],[7.501785,56.26392]]]},"properties":{"code":"DK","count":2,"region":"Denmark"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.48583,42.733883],[23.48583,43.733883],[27.48583,43.733883],[27.48583,42.733883],[23.48583,42.733883]]]},"properties":{"code":"BG","count":1,"region":"Bulgaria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[13.472962,49.817492],[13.472962,50.817492],[17.472962000000003,50.817492],[17.472962000000003,49.817492],[13.472962,49.817492]]]},"properties":{"code":"CZ","count":1,"region":"Czech Republic"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.74922,40.463667],[-5.74922,41.463667],[-1.7492200000000002,41.463667],[-1.7492200000000002,40.463667],[-5.74922,40.463667]]]},"properties":{"code":"ES","count":1,"region":"Spain"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[0.21374899999999997,46.227638],[0.21374899999999997,47.227638],[4.213749,47.227638],[4.213749,46.227638],[0.21374899999999997,46.227638]]]},"properties":{"code":"FR","count":1,"region":"France"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-10.24389,53.41291],[-10.24389,54.41291],[-6.24389,54.41291],[-6.24389,53.41291],[-10.24389,53.41291]]]},"properties":{"code":"IE","count":1,"region":"Ireland"}}]}
Index: /other-projects/maori-lang-detection/mongodb-data/multipoint_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/multipoint_nonProductSites1_manualShortlist.json	(revision 33821)
+++ /other-projects/maori-lang-detection/mongodb-data/multipoint_nonProductSites1_manualShortlist.json	(revision 33821)
@@ -0,0 +1,13 @@
+{"type":"MultiPoint","coordinates":
+[
+	[174.885971,-40.900557],
+	[-95.712891,37.09024],
+	[133.775136,-25.274398],
+	[10.451526,51.165691],
+	[9.501785,56.26392],
+	[25.48583,42.733883],
+	[15.472962,49.817492],
+	[-3.74922,40.463667],
+	[2.213749,46.227638],
+	[-8.24389,53.41291]
+]}